#!perl

use strict;
use MaterialsScript qw(:all);

my $doc = $Documents{"structure.xsd"};
#my $energy_table = $Documents{"energies.std"};
my $tors1;
my $tors2;
my $clm_cnt = 0;

#$energy_table->ClearContent;

my $sets = $doc->UnitCell->Sets;
foreach my $set (@$sets) 
{
	print $set->Delete;
}

my $bonds = $doc->UnitCell->Bonds;
my $set_name = 0;
foreach my $bond (@$bonds) 
{
	if($bond->BondType eq "Double")
	{
		$doc->CreateSet($set_name, [$bond->Atom1, $bond->Atom2]);
		$set_name++;
	}
}

exit;

for (my $a = 0; $a <= 1; $a++)
{
	for (my $b = 0; $b <= 1; $b++)
	{
		for (my $c = 0; $c <= 1; $c++)
		{
			for (my $d = 0; $d <= 1; $d++)
			{
				for (my $e = 0; $e <= 1; $e++)
				{
					for (my $f = 0; $f <= 1; $f++)
					{
						for (my $g = 0; $g <= 1; $g++)
						{
							for (my $h = 0; $h <= 1; $h++)
							{
								for (my $i = 0; $i <= 1; $i++)
								{
									for (my $j = 0; $j <= 1; $j++)
									{
										for (my $k = 0; $k <= 1; $k++)
										{
											for (my $l = 0; $l <= 1; $l++)
											{
												create_structure($a, $b, $c, $d, $e, $f, $g, $h, $i, $j, $k, $l);															
											} 
										} 
									} 
								} 
							} 
						} 									
					} 
				} 
			} 
		} 
	} 
}

sub create_structure
{
	my $filename = $_[0]."_".$_[1]."_".$_[2]."_".$_[3]."_".$_[4]."_".$_[5]."_".$_[6]."_".$_[7]."_".$_[8]."_".$_[9]."_".$_[10]."_".$_[11];
	$doc->Export("path/$filename.xsd");
		
	my $doc_imp = Documents->Import("path/$filename.xsd");
	unlink("path/$filename.xsd");
	#$doc->Export("$filename.xsd");
		
	#my $doc_imp = Documents->Import("$filename.xsd");
	my $linker_index = 0;
	my $sets = $doc_imp->UnitCell->Sets;
	foreach my $set (@$sets) 
	{
		my $x1 = ($set->Item(0)->X+$set->Item(1)->X)/2;
		my $y1 = ($set->Item(0)->Y+$set->Item(1)->Y)/2;
		my $z1 = ($set->Item(0)->Z+$set->Item(1)->Z)/2;
		my $c_carboxy1;
		my $c_carboxy2;
		my $o_carboxy1;
		my $o_carboxy2;
		
		my $connectedAtoms = $set->Item(0)->AttachedAtoms;
		foreach my $atom (@$connectedAtoms) 
		{
			if($atom->NumBonds == 3)
			{
				$c_carboxy1 = $atom;
				my $connectedAtoms_c_carboxy1 = $c_carboxy1->AttachedAtoms;
				foreach my $atom_c_carboxy1 (@$connectedAtoms_c_carboxy1) 
				{
					if($atom_c_carboxy1->ElementSymbol eq "O")
					{
						$o_carboxy1 = $atom_c_carboxy1;
					}
				}
			}
		}
		my $connectedAtoms = $set->Item(1)->AttachedAtoms;
		foreach my $atom (@$connectedAtoms) 
		{
			if($atom->NumBonds == 3)
			{
				$c_carboxy2 = $atom;
				my $connectedAtoms_c_carboxy2 = $c_carboxy2->AttachedAtoms;
				foreach my $atom_c_carboxy2 (@$connectedAtoms_c_carboxy2) 
				{
					if($atom_c_carboxy2->ElementSymbol eq "O")
					{
						$o_carboxy2 = $atom_c_carboxy2;
					}
				}
			}
		}
	
		my $vec_x = $c_carboxy1->X-$c_carboxy2->X;
		my $vec_y = $c_carboxy1->Y-$c_carboxy2->Y;
		my $vec_z = $c_carboxy1->Z-$c_carboxy2->Z;
		if($_[$linker_index] == 1)
		{
			$set->RotateAboutPoint(180.0, Point(X => $vec_x, Y => $vec_y, Z => $vec_z), Point(X => $x1, Y => $y1, Z => $z1));
		}
		$tors1 = $doc_imp->UnitCell->CreateTorsion([$o_carboxy1, $c_carboxy1, $set->Item(0), $set->Item(1)]);
		$tors2 = $doc_imp->UnitCell->CreateTorsion([$o_carboxy2, $c_carboxy2, $set->Item(1), $set->Item(0)]);
		$linker_index++;
	}
	$doc_imp->UnitCell->AdjustHydrogen;

	$tors1->Fix("Angle");
	$tors2->Fix("Angle");
	#my $opt = Modules->Forcite;
	#$opt->ChangeSettings(Settings(MaxIterations => 5000, OptimizeCell => "yes", KeepMotionGroupsRigid => "yes", WriteLevel => "Silent", CurrentForcefield => "Universal", Quality => "Medium"));
	#$opt->GeometryOptimization->Run($doc_imp);
	#$tors1->Unfix("Angle");
	#$tors2->Unfix("Angle");
	#my $spaceg = $doc_imp->FindSymmetry;
	#$energy_table->Cell($clm_cnt, 0) = $filename;
	#$energy_table->Cell($clm_cnt, 1) = $doc_imp->PotentialEnergy;
	#$energy_table->Cell($clm_cnt, 2) = $spaceg->GroupName;
	#$energy_table->Cell($clm_cnt, 3) = $spaceg->SpaceGroupITNumber;
	$doc_imp->Export("path/$filename.xsd");
	$doc_imp->Discard;
	$clm_cnt++;
}