#!perl

use strict;
use Getopt::Long;
use MaterialsScript qw(:all);

my $name = "structure";

my $doc = $Documents{$name.".xsd"};
my $txt_doc = Documents->New($name.".txt");

$doc->MakeP1;

$txt_doc->Append("<cell>\n");
$txt_doc->Append("a ".$doc->SymmetryDefinition->LengthA."\n");
$txt_doc->Append("b ".$doc->SymmetryDefinition->LengthB."\n");
$txt_doc->Append("c ".$doc->SymmetryDefinition->LengthC."\n");
$txt_doc->Append("alpha ".$doc->SymmetryDefinition->AngleAlpha."\n");
$txt_doc->Append("beta ".$doc->SymmetryDefinition->AngleBeta."\n");
$txt_doc->Append("gamma ".$doc->SymmetryDefinition->AngleGamma."\n");
$txt_doc->Append("</cell>\n");
$txt_doc->Append("<atom_x_y_z_charge>\n");
my $atoms = $doc->UnitCell->Atoms;
foreach my $atom (@$atoms) 
{
	$txt_doc->Append($atom->ElementSymbol." ".wrap_into_cell($atom->X, $doc->SymmetryDefinition->LengthA)." ".wrap_into_cell($atom->Y, $doc->SymmetryDefinition->LengthB)." ".wrap_into_cell($atom->Z, $doc->SymmetryDefinition->LengthC)." ".sprintf("%.5f",$atom->Charge)."\n");
}
$txt_doc->Append("</atom_x_y_z_charge>");

sub wrap_into_cell
{
	my $coord = $_[0];
	my $cell = $_[1];
	while ($coord>$cell)
	{
		$coord = $coord-$cell;
	}
	while ($coord<0)
	{
		$coord = $coord+$cell;
	}
	$coord = sprintf("%.5f",$coord);
	return $coord;
}