import pylab
import numpy
import scipy
import scipy.optimize
import scipy.linalg
import random
import sys
import math
import os

def read_csv_isotherm(filename, min_p, max_p):
	csv_data = []
	p_data = []
	v_data = []
	ins = open(filename, "r")
	for line in ins:
		if ("," in line):
			if (float(line.split(",")[0].strip())<=max_p) and (float(line.split(",")[0].strip())>=min_p):
				csv_data.append([float(line.split(",")[0].strip()), float(line.split(",")[1].strip())])
				p_data.append(float(line.split(",")[0].strip()))
				v_data.append(float(line.split(",")[1].strip()))
	ins.close()
	#p to p/p0
	p0_ar_kpa = 771.94*0.133 
	#for i in range(0,len(p_data)):
	#	p_data[i] = p_data[i]/p0_ar_kpa
	return csv_data, p_data, v_data
	
def make_diff_data(data_exp):
	p0 = 100
	dv_dlog_p_p0 = []
	for i in range(1,len(data_exp)):
		dv_dlog_p_p0.append((data_exp[i][1]-data_exp[i-1][1])/(numpy.log(data_exp[i][0]/p0)-numpy.log(data_exp[i-1][0]/p0)))
	return dv_dlog_p_p0
	
def write_csv(csv_file, p_rel, dv_dlog_p_p0):
		fo = open(csv_file, "w")
		for i in range(0,len(p_rel)):
			fo.write(str(p_rel[i])+","+str(dv_dlog_p_p0[i])+"\n")
		fo.close()
	
data_exp_p2, p_data_exp_p2, v_data_exp_p2 = read_csv_isotherm("Exp_data.csv", 0., 100.)
dv_dlog_p_p0_p2 = make_diff_data(data_exp_p2)
dv_dlog_p_p0_p2.append(dv_dlog_p_p0_p2[-1])
pylab.plot(p_data_exp_p2, dv_dlog_p_p0_p2, marker='o', linestyle='-', color='g', label='Experimental')

pylab.gca().set_xscale('log')
pylab.gca().set_yscale('log')
pylab.legend(loc='upper left')
pylab.grid(True)
#pylab.savefig("figure.png", format='png', dpi=400)
pylab.show()