import pylab
import numpy
import scipy
import scipy.optimize
import scipy.linalg
import CoolProp.CoolProp #Requires CoolProp python module (http://coolprop.org/)
import random
import sys
import math
import os
import sqlite3
import shutil
import Tkinter
import tkFileDialog
import tkMessageBox
import copy

#Instanz von TKinter initialisieren
pyTowheeRoot=Tkinter.Tk()
pyTowheeRoot.title("pyTowhee (BETA)")

#Dialog zum Auswaehlen eines Verzeichnisses
def select_dir():
	dirname = tkFileDialog.askdirectory(parent=mainframe,initialdir="/",title='Select root directory')
	root_dir_entry.delete(0, 500)
	root_dir_entry.insert(0, dirname)

#Dateien im angegebenen Dateipfad auflisten	
def list_files(path):
	dir_content_list = os.listdir(path)
	file_list = []
	for dir_content in dir_content_list:
		if (os.path.isfile(path+"/"+dir_content)==1):
			file_list.append(dir_content)
	return file_list

#Verfuegbare Adsorptive aus Datenbank laden	
def list_adsorptives():
	ads_manual_list = ["He", "Ne", "Ar", "Kr", "Xe"]
	ads_manual_list2 = ["CH4"]
	conn = sqlite3.connect("force_field_100514.db")
	atom_name_list = []
	ff_name_list = []
	display_list = []
	for ads_manual in ads_manual_list:
		cursor = conn.execute("SELECT DISTINCT Force_Field_Name, Atom_Names from lj_parameters WHERE Element = '"+ads_manual+"'")
		for row in cursor:
			ff_name_list.append(row[0])
			atom_name_list.append(row[1])
			display_list.append(str(row[1])+" ("+str(row[0])+")")
	for ads_manual2 in ads_manual_list2:
		cursor = conn.execute("SELECT DISTINCT Force_Field_Name, Atom_Names from lj_parameters WHERE Atom_Names = '"+ads_manual2+"'")
		for row in cursor:
			ff_name_list.append(row[0])
			atom_name_list.append(row[1])
			display_list.append(str(row[1])+" ("+str(row[0])+")")
	cursor = conn.execute("SELECT Force_Field_Name, Adsorptive from three_parameters")
	for row in cursor:
		ff_name_list.append(row[0])
		atom_name_list.append(row[1])
		display_list.append(str(row[1])+" ("+str(row[0])+")")
	conn.close()
	return atom_name_list, ff_name_list, display_list

#Element zu Atomtyp aus Datenbank laden	
def get_element_from_ff_type(root_python_pwd, ff_name, ff_type):
	ads_abb_list = ["He", "Ne", "Ar", "Kr", "Xe", "CH4", "N2", "CO2"]
	ads_full_list = ["Helium", "Neon", "Argon", "Krypton", "Xenon", "Methane", "Nitrogen", "CO2"]
	conn = sqlite3.connect(root_python_pwd+"/force_field_100514.db")
	element_abb = ""
	element = ""
	#print ff_name
	#print ff_type
	cursor = conn.execute("SELECT DISTINCT Element from lj_parameters WHERE Force_Field_Name = '"+ff_name+"' and Atom_Names = '"+ff_type+"'")
	for row in cursor:
		element_abb = row[0]
	conn.close()
	for i in range(0,len(ads_abb_list)):
		if ads_abb_list[i]==ff_type:
			element = ads_full_list[i]
		if ads_abb_list[i]==element_abb:
			element = ads_full_list[i]
	return element

#Eingegebene Parameter in Datenbank speichern	
def save_to_db():
	conn = sqlite3.connect("projects.db")
	cursor = conn.execute("INSERT INTO projects (project_name, description, root_dir, remote_root, ff_file, adsorbent, adsorbent_ff, adsorptive, adsorptive_M, start_p, end_p, num_points, p_range, min_load, max_load, temperature, rcut, rcutin, cut_corr, nstep, printfreq, blocksize, moviefreq, backupfreq, trmaxdispfreq, volmaxdispfreq, pdb_output_freq, pressurefreq, pmvol, pm2boxcbswap, pm1boxcbswap, pmtraat, pmtracm, pmrotate, rrzn_ram, rrzn_walltime) VALUES ('"+project_name_entry.get()+"', '"+description_entry.get()+"', '"+root_dir_entry.get()+"', '"+remote_root_entry.get()+"', '"+ff_file_entry.get()+"', '"+adsorbent_option_choices_start.get()+"', '"+adsorbent_ff_option_choices_start.get()+"', '"+adsorptive_option_choices_start.get()+"', "+adsorptive_M_entry.get()+", "+start_p_entry.get()+", "+end_p_entry.get()+", "+num_points_entry.get()+", '"+p_range_option_choices_start.get()+"', "+min_load_entry.get()+", "+max_load_entry.get()+",  "+temperature_entry.get()+", "+rcut_entry.get()+", "+rcutin_entry.get()+", '"+cut_corr_option_choices_start.get()+"', "+nstep_entry.get()+", "+printfreq_entry.get()+", "+blocksize_entry.get()+", "+moviefreq_entry.get()+", "+backupfreq_entry.get()+", "+trmaxdispfreq_entry.get()+", "+volmaxdispfreq_entry.get()+", "+pdb_output_freq_entry.get()+", "+pressurefreq_entry.get()+", "+pmvol_entry.get()+", "+pm2boxcbswap_entry.get()+", "+pm1boxcbswap_entry.get()+", "+pmtraat_entry.get()+", "+pmtracm_entry.get()+", "+pmrotate_entry.get()+", "+rrzn_ram_entry.get()+", "+rrzn_walltime_entry.get()+");")
	#cursor = conn.execute("INSERT INTO projects (project_name, description, root_dir, remote_root, ff_file, adsorbent, adsorbent_ff, adsorptive, adsorptive_M, start_p, end_p, num_points, p_range, min_load, max_load, temperature, rcut, rcutin, cut_corr, nstep, printfreq, blocksize, moviefreq, backupfreq, trmaxdispfreq, volmaxdispfreq, pdb_output_freq, pressurefreq, pmvol, pm2boxcbswap, pm1boxcbswap, pmtraat, pmtracm, pmrotate) VALUES ('abc', 'abc', 'abc', 'abc', 'abc', 'abc', 'abc', 'abc', 1.0, 1.0, 1.0, 1, 'abc', 1, 1,  1.0, 1.0, 1.0, 'abc', 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0);")
	conn.commit()
	conn.close()
	tkMessageBox.showinfo("pyTowhee", "Data saved.")
	#print "INSERT INTO projects (project_name, description, root_dir, remote_root, ff_file, adsorbent, adsorbent_ff, adsorptive, adsorptive_M, start_p, end_p, num_points, p_range, min_load, max_load, temperature, rcut, rcutin, cut_corr, nstep, printfreq, blocksize, moviefreq, backupfreq, trmaxdispfreq, volmaxdispfreq, pdb_output_freq, pressurefreq, pmvol, pm2boxcbswap, pm1boxcbswap, pmtraat, pmtracm, pmrotate) VALUES ('"+project_name_entry.get()+"', '"+description_entry.get()+"', '"+root_dir_entry.get()+"', '"+remote_root_entry.get()+"', '"+ff_file_entry.get()+"', '"+adsorbent_option_choices_start.get()+"', '"+adsorbent_ff_option_choices_start.get()+"', '"+adsorptive_option_choices_start.get()+"', "+adsorptive_M_entry.get()+", "+start_p_entry.get()+", "+end_p_entry.get()+", "+num_points_entry.get()+", '"+p_range_option_choices_start.get()+"', "+min_load_entry.get()+", "+max_load_entry.get()+",  "+temperature_entry.get()+", "+rcut_entry.get()+", "+rcutin_entry.get()+", '"+cut_corr_option_choices_start.get()+"', "+nstep_entry.get()+", "+printfreq_entry.get()+", "+blocksize_entry.get()+", "+moviefreq_entry.get()+", "+backupfreq_entry.get()+", "+trmaxdispfreq_entry.get()+", "+volmaxdispfreq_entry.get()+", "+pdb_output_freq_entry.get()+", "+pressurefreq_entry.get()+", "+pmvol_entry.get()+", "+pm2boxcbswap_entry.get()+", "+pm1boxcbswap_entry.get()+", "+pmtraat_entry.get()+", "+pmtracm_entry.get()+", "+pmrotate_entry.get()+");"

#Parameter aus Datenbank laden
def load_from_db():
	global LoadWin, start_value, listbox, num_entries
	start_value = 0
	conn = sqlite3.connect("projects.db")
	LoadWin=Tkinter.Tk()
	cursor = conn.execute("SELECT ID, project_name, description FROM projects ORDER BY ID asc")
	num_entries = len(cursor.fetchall())
	LoadWin.title("Load ("+str(num_entries)+" Entries)")
	LoadWin.iconbitmap("pyTowhee.ico")
	loadframe = Tkinter.Frame(LoadWin)
	loadframe.grid()
	Tkinter.Label(loadframe, text="Saved Projects").grid(row=0, sticky="W")
	listbox = Tkinter.Listbox(loadframe, width="100")
	listbox.grid(row=1, column=0, columnspan=2, sticky="W")
	cursor = conn.execute("SELECT ID, project_name, description FROM projects ORDER BY ID asc LIMIT "+str(start_value)+", "+str(start_value+10))
	for row in cursor:
		listbox.insert(Tkinter.END, str(row[0])+", "+str(row[1])+", "+str(row[2]))
	conn.close()
	back_button = Tkinter.Button(loadframe, text="Back", command=lambda: forward_backward_loadwin(start_value-10))
	back_button.grid(row=2, column=0, sticky="E")
	back_button = Tkinter.Button(loadframe, text="Next", command=lambda: forward_backward_loadwin(start_value+10))
	back_button.grid(row=2, column=1, sticky="W")
	load_button = Tkinter.Button(loadframe, text="Load data", command=lambda: load_from_db_submit(listbox.get(Tkinter.ACTIVE)))
	load_button.grid(row=3, column=0, sticky="E")
	del_button = Tkinter.Button(loadframe, text="Delete data", command=lambda: del_from_db_submit(listbox.get(Tkinter.ACTIVE)))
	del_button.grid(row=3, column=1, sticky="W")
	LoadWin.mainloop()

#Fenster aktualisieren	
def forward_backward_loadwin(start_new):
	global LoadWin, start_value, listbox
	if start_new>=0 and start_new<=(num_entries-1):
		listbox.delete(0, 10)
		conn = sqlite3.connect("projects.db")
		cursor = conn.execute("SELECT ID, project_name, description FROM projects ORDER BY ID asc LIMIT "+str(start_new)+", "+str(start_new+10))
		for row in cursor:
			listbox.insert(Tkinter.END, str(row[0])+", "+str(row[1])+", "+str(row[2]))
		conn.close()
		start_value = start_new

#Parameter aus Datenbank loeschen		
def del_from_db_submit(entry):
	global LoadWin
	db_id = int(entry.split(",")[0])
	LoadWin.destroy()
	conn = sqlite3.connect("projects.db")
	cursor = conn.execute("DELETE FROM projects WHERE ID='"+str(db_id)+"'")
	conn.commit()
	conn.close()
	tkMessageBox.showinfo("pyTowhee", "Database entry with the ID "+str(db_id)+" deleted.")
	load_from_db()

#Aus Datenbank geladene Parameter in Fenster einfuegen	
def load_from_db_submit(entry):
	db_id = int(entry.split(",")[0])
	conn = sqlite3.connect("projects.db")
	cursor = conn.execute("SELECT DISTINCT project_name, description, root_dir, remote_root, ff_file, adsorbent, adsorbent_ff, adsorptive, adsorptive_M, start_p, end_p, num_points, p_range, min_load, max_load, temperature, rcut, rcutin, cut_corr, nstep, printfreq, blocksize, moviefreq, backupfreq, trmaxdispfreq, volmaxdispfreq, pdb_output_freq, pressurefreq, pmvol, pm2boxcbswap, pm1boxcbswap, pmtraat, pmtracm, pmrotate, rrzn_ram, rrzn_walltime FROM projects WHERE ID='"+str(db_id)+"'")
	for row in cursor:
		project_name_entry.delete(0, Tkinter.END)
		description_entry.delete(0, Tkinter.END)
		root_dir_entry.delete(0, Tkinter.END)
		remote_root_entry.delete(0, Tkinter.END)
		ff_file_entry.delete(0, Tkinter.END)
		adsorbent_option_choices_start.set(row[5])
		adsorbent_ff_option_choices_start.set(row[6])
		adsorptive_option_choices_start.set(row[7])
		adsorptive_M_entry.delete(0, Tkinter.END)
		start_p_entry.delete(0, Tkinter.END)
		end_p_entry.delete(0, Tkinter.END)
		num_points_entry.delete(0, Tkinter.END)
		p_range_option_choices_start.set(row[12])
		min_load_entry.delete(0, Tkinter.END)
		max_load_entry.delete(0, Tkinter.END)
		temperature_entry.delete(0, Tkinter.END)
		rcut_entry.delete(0, Tkinter.END)
		rcutin_entry.delete(0, Tkinter.END)
		cut_corr_option_choices_start.set(row[18])
		nstep_entry.delete(0, Tkinter.END)
		printfreq_entry.delete(0, Tkinter.END)
		blocksize_entry.delete(0, Tkinter.END)
		moviefreq_entry.delete(0, Tkinter.END)
		backupfreq_entry.delete(0, Tkinter.END)
		trmaxdispfreq_entry.delete(0, Tkinter.END)
		volmaxdispfreq_entry.delete(0, Tkinter.END)
		pdb_output_freq_entry.delete(0, Tkinter.END)
		pressurefreq_entry.delete(0, Tkinter.END)
		pmvol_entry.delete(0, Tkinter.END)
		pm2boxcbswap_entry.delete(0, Tkinter.END)
		pm1boxcbswap_entry.delete(0, Tkinter.END)
		pmtraat_entry.delete(0, Tkinter.END)
		pmtracm_entry.delete(0, Tkinter.END)
		pmrotate_entry.delete(0, Tkinter.END)
		rrzn_ram_entry.delete(0, Tkinter.END)
		rrzn_walltime_entry.delete(0, Tkinter.END)
		
		project_name_entry.insert(0, row[0])
		description_entry.insert(0, row[1])
		root_dir_entry.insert(0, row[2])
		remote_root_entry.insert(0, row[3])
		ff_file_entry.insert(0, row[4])
		adsorptive_M_entry.insert(0, row[8])
		start_p_entry.insert(0, row[9])
		end_p_entry.insert(0, row[10])
		num_points_entry.insert(0, row[11])
		min_load_entry.insert(0, row[13])
		max_load_entry.insert(0, row[14])
		temperature_entry.insert(0, row[15])
		rcut_entry.insert(0, row[16])
		rcutin_entry.insert(0, row[17])
		nstep_entry.insert(0, row[19])
		printfreq_entry.insert(0, row[20])
		blocksize_entry.insert(0, row[21])
		moviefreq_entry.insert(0, row[22])
		backupfreq_entry.insert(0, row[23])
		trmaxdispfreq_entry.insert(0, row[24])
		volmaxdispfreq_entry.insert(0, row[25])
		pdb_output_freq_entry.insert(0, row[26])
		pressurefreq_entry.insert(0, row[27])
		pmvol_entry.insert(0, row[28])
		pm2boxcbswap_entry.insert(0, row[29])
		pm1boxcbswap_entry.insert(0, row[30])
		pmtraat_entry.insert(0, row[31])
		pmtracm_entry.insert(0, row[32])
		pmrotate_entry.insert(0, row[33])
		rrzn_ram_entry.insert(0, int(row[34]))
		rrzn_walltime_entry.insert(0, int(row[35]))
	conn.close()	

#Projekt erstellen (Ordnerstruktur, Kraftfelddateien, Inputdateien etc.)	
def submit_data():
	tkMessageBox.showinfo("pyTowhee", "Generating files: This make take a while! Don't close pyTowhee!")
	pytowhee_root = copy.deepcopy(os.getcwd())
	pytowhee_root = pytowhee_root.replace('\\',"/")
	if p_range_option_choices_start.get()=="Linear":
		pressure_loading_list = gen_pressure_load_range([[float(start_p_entry.get()), float(end_p_entry.get()), int(num_points_entry.get()), int(max_load_entry.get())]])
	else:
		pressure_loading_list = gen_pressure_load_range_lg([[float(start_p_entry.get()), float(end_p_entry.get()), int(num_points_entry.get()), int(max_load_entry.get())]])
		
	for i in range(0,len(pressure_loading_list)):
		if pressure_loading_list[i][0]<=0.1:
			pressure_loading_list[i][1] = int(min_load_entry.get())
	
	isotherm_project_dir = create_towhee_project(root_dir_entry.get()+"/"+project_name_entry.get()) #Top level directory for isotherm project
	print "Creating Towhee isotherm project "+str(project_name_entry.get())+"\n"
	start_paths = []
	start_names = []
	cell_a_tmp = 0
	cell_b_tmp = 0
	cell_c_tmp = 0
	cell_alpha_tmp = 0
	cell_beta_tmp = 0
	cell_gamma_tmp = 0
	framework_atoms_tmp = []
	ff_filename_only = ""
	for pressure_loading in pressure_loading_list:
		project_name = create_towhee_project(str(project_name_entry.get())+"_"+str(pressure_loading[0]).replace(".","_")+"kpa") #Creates directory for new project
		msg_setup = "Setup for pressure "+str(pressure_loading[0])+" kPa"
		print msg_setup
		print len(msg_setup)*"-"
		new_towhee = towhee_npt_isotherm()
		new_towhee.pytowhee_root = pytowhee_root
		new_towhee.ff_filename = remote_root_entry.get()+"/"+str(project_name_entry.get())+"/"+str(project_name)+"/"+ff_file_entry.get()
		new_towhee.forcefield = ff_file_entry.get()
		if cut_corr_option_choices_start.get()=="Tail":
			new_towhee.lshift = "F"
			new_towhee.ltailc = "T"
		else:
			new_towhee.lshift = "T"
			new_towhee.ltailc = "F"
		new_towhee.rmin = 1.0
		new_towhee.rcut = float(rcut_entry.get())
		new_towhee.rcutin = float(rcutin_entry.get())
		new_towhee.nstep = int(nstep_entry.get())
		new_towhee.printfreq = int(printfreq_entry.get())
		new_towhee.blocksize = int(blocksize_entry.get())
		new_towhee.moviefreq = int(moviefreq_entry.get())
		new_towhee.backupfreq = int(backupfreq_entry.get())
		#+++Best Setup so far, no VOL-Errors+++
		#new_towhee.trmaxdispfreq = 1
		#new_towhee.volmaxdispfreq = 1000
		#new_towhee.pdb_output_freq = 0
		#new_towhee.pressurefreq = 10
		#new_towhee.pmvol = 0.01
		#new_towhee.pm2boxcbswap = 0.2
		#new_towhee.pm1boxcbswap = 0.1
		#new_towhee.pmtraat = 0.0
		#new_towhee.pmtracm = 1.0
		#new_towhee.pmrotate = 0.0
		#+++++++++++++++++++++++++++++++++++++
		new_towhee.trmaxdispfreq = int(trmaxdispfreq_entry.get())
		new_towhee.volmaxdispfreq = int(volmaxdispfreq_entry.get())
		new_towhee.pdb_output_freq = int(pdb_output_freq_entry.get())
		new_towhee.pressurefreq = int(pressurefreq_entry.get())
		new_towhee.pmvol = float(pmvol_entry.get())
		new_towhee.pm2boxcbswap = float(pm2boxcbswap_entry.get())
		new_towhee.pm1boxcbswap = float(pm1boxcbswap_entry.get())
		new_towhee.pmtraat = float(pmtraat_entry.get())
		new_towhee.pmtracm = float(pmtracm_entry.get())
		new_towhee.pmrotate = float(pmrotate_entry.get())
		if len(framework_atoms_tmp)<1:
			new_towhee.read_framework(pytowhee_root+"/structures/"+adsorbent_option_choices_start.get()) #Read in structure and charges
			new_towhee.unit_cell_vecs() #Calculate unit cell vectors
			new_towhee.correct_min_dist() #Check for small distances
			cell_a_tmp = new_towhee.cell_a
			cell_b_tmp = new_towhee.cell_b
			cell_c_tmp = new_towhee.cell_c
			cell_alpha_tmp = new_towhee.cell_alpha
			cell_beta_tmp = new_towhee.cell_beta
			cell_gamma_tmp = new_towhee.cell_gamma
			framework_atoms_tmp = new_towhee.framework_atoms
		else:
			new_towhee.cell_a = cell_a_tmp
			new_towhee.cell_b = cell_b_tmp
			new_towhee.cell_c = cell_c_tmp
			new_towhee.cell_alpha = cell_alpha_tmp
			new_towhee.cell_beta = cell_beta_tmp
			new_towhee.cell_gamma = cell_gamma_tmp
			new_towhee.framework_atoms = framework_atoms_tmp
			new_towhee.unit_cell_vecs() #Calculate unit cell vectors
		start_paths.append(remote_root_entry.get()+"/"+str(project_name_entry.get())+"/"+str(project_name))
		start_names.append(str(project_name))
		framework_elements = []
		for framework_atom in new_towhee.framework_atoms:
			if framework_atom[0] not in framework_elements:
				framework_elements.append(framework_atom[0])
		framework_types = new_towhee.assign_framework_ff_types(framework_elements, adsorbent_ff_option_choices_start.get())
		#framework_types = [["C_3", "DREIDING"], ["H_", "DREIDING"], ["O_3", "DREIDING"], ["Zr3+4", "UFF"]] #List to assign forcefield types for given atom types (framework)
		new_towhee.adsorptive = (adsorptive_option_choices_start.get()).split(" ")[0]
		adsorptive_ff = (adsorptive_option_choices_start.get()).split(" ")[1]
		adsorptive_ff = adsorptive_ff.replace("(", "")
		adsorptive_ff = adsorptive_ff.replace(")", "")
		#new_towhee.adsorptive = "Ar" #Adsorptive name in DB (for example CO2 or Ar)
		#adsorptive_ff = "RNP" #Force_Field_Name in DB
		new_towhee.create_ff_file(new_towhee.forcefield, new_towhee.forcefield, framework_types, new_towhee.adsorptive, adsorptive_ff) #Create force field file
		ff_filename_only = new_towhee.forcefield
		new_towhee.temperature = float(temperature_entry.get())
		new_towhee.pressure = pressure_loading[0]
		#new_towhee.coolprop_name = "Argon" #Name of adsorptive in CoolProp database
		#new_towhee.coolprop_name = new_towhee.coolprop_names[new_towhee.adsorptive]
		new_towhee.coolprop_name = get_element_from_ff_type(pytowhee_root, adsorptive_ff, new_towhee.adsorptive)
		new_towhee.min_mol_num = pressure_loading[1] #Minimum number of molecules in box 2 (start values for density scaling)
		molecule_mass = float(adsorptive_M_entry.get())
		target_density = new_towhee.coolprop_density(new_towhee.pressure,new_towhee.temperature,new_towhee.coolprop_name)
		mol_num, cell_length, deviation = new_towhee.density_to_cubic_cell_mol_num(target_density,molecule_mass)
		print str(mol_num)+"x "+new_towhee.coolprop_name+" in cubic cell with cell length "+str(cell_length)+" A (Density deviation: "+str(round(deviation*100,4))+" %)\n"
		new_towhee.cell_length = cell_length #Scaled cell length of box 2 (according to experimental density)
		new_towhee.create_input_files("towhee_input", "towhee_coords")
		os.chdir('../')
	print "Done creating Isotherm project.\n"
	create_py_script_isotherms(start_paths) #Creates python script to start calculations locally
	rrzn_py_scripts(start_paths, start_names, ff_filename_only, rrzn_ram_entry.get(), rrzn_walltime_entry.get()) #Create python scripts for the RRZN cluster
	os.chdir(pytowhee_root)
	tkMessageBox.showinfo("pyTowhee", "Done!")

#Klasse mit Funktionen zum Erstellen der Projekttdateien	
class towhee_npt_isotherm:

	#Konstruktor der Klasse: Zuweisen von Variablen
	def __init__(self):
		self.avogadro = 6.02214129*10**23
		self.pytowhee_root = "./"
		self.kb = 1.3806505*10**-23
		self.vdw_radius = {"H": 1.20, "D": 1.20, "He": 1.40, "Li": 1.82, "Be": 0.63, "B": 1.75, "C": 1.775, "N": 1.50, "O": 1.45, "F": 1.47, "Ne": 1.54, "Na": 2.27, "Mg": 1.73, "Al": 1.50, "Si": 2.10, "P": 1.90, "S": 1.80, "Cl": 1.75, "Ar": 1.88, "K": 2.75, "Ca": 1.95, "Sc": 1.32, "Ti": 1.95, "V": 1.06, "Cr": 1.13, "Mn": 1.19, "Fe": 1.26, "Co": 1.13, "Ni": 1.63, "Cu": 1.40, "Zn": 1.39, "Ga": 1.87, "Ge": 1.48, "As": 0.83, "Se": 1.90, "Br": 1.85, "Kr": 2.02, "Rb": 2.65, "Sr": 2.02, "Y": 1.61, "Zr": 1.42, "Nb": 1.33, "Mo": 1.75, "Tc": 2.00, "Ru": 1.20, "Rh": 1.22, "Pd": 1.63, "Ag": 1.72, "Cd": 1.58, "In": 1.93, "Sn": 2.17, "Sb": 1.12, "Te": 1.26, "I": 1.98, "Xe": 2.16, "Cs": 3.01, "Ba": 2.41, "La": 1.83, "Ce": 1.86, "Pr": 1.62, "Nd": 1.79, "Pm": 1.76, "Sm": 1.74, "Eu": 1.96, "Gd": 1.69, "Tb": 1.66, "Dy": 1.63, "Ho": 1.61, "Er": 1.59, "Tm": 1.57, "Yb": 1.54, "Lu": 1.53, "Hf": 1.40, "Ta": 1.22, "W": 1.26, "Re": 1.30, "Os": 1.58, "Ir": 1.22, "Pt": 1.72, "Au": 1.66, "Hg": 1.55, "Tl": 1.96, "Pb": 2.02, "Bi": 1.73, "Po": 1.21, "At": 1.12, "Rn": 2.30, "Fr": 3.24, "Ra": 2.57, "Ac": 2.12, "Th": 1.84, "Pa": 1.60, "U": 1.75, "Np": 1.71, "Pu": 1.67, "Am": 1.66, "Cm": 1.65, "Bk": 1.64, "Cf": 1.63, "Es": 1.62, "Fm": 1.61, "Md": 1.60, "No": 1.59, "Lr": 1.58}
		self.cov_radius = {"H": 0.32, "He": 0.93, "Li": 1.23, "Be": 0.9, "B": 0.82, "C": 0.77, "N": 0.75, "O": 0.73, "F": 0.72, "Ne": 0.71, "Na": 1.53, "Mg": 1.36, "Al": 1.18, "Si": 1.1, "P": 1.06, "S": 1.02, "Cl": 0.99, "Ar": 0.98, "K": 2.03, "Ca": 1.74, "Sc": 1.44, "Ti": 1.32, "V": 1.22, "Cr": 1.18, "Mn": 1.17, "Fe": 1.17, "Co": 1.16, "Ni": 1.15, "Cu": 1.17, "Zn": 1.25, "Ga": 1.26, "Ge": 1.22, "As": 1.2, "Se": 1.16, "Br": 1.14, "Kr": 1.89, "Rb": 2.16, "Sr": 1.91, "Y": 1.62, "Zr": 1.45, "Nb": 1.34, "Mo": 1.3, "Tc": 1.27, "Ru": 1.25, "Rh": 1.25, "Pd": 1.28, "Ag": 1.34, "Cd": 1.41, "In": 1.44, "Sn": 1.41, "Sb": 1.4, "Te": 1.6, "I": 1.33, "Xe": 1.31, "Cs": 2.35, "Ba": 1.98, "La": 1.25, "Hf": 1.44, "Ta": 1.34, "W": 1.3, "Re": 1.28, "Os": 1.26, "Ir": 1.27, "Pt": 1.3, "Au": 1.34, "Hg": 1.49, "Tl": 1.48, "Pb": 1.47, "Bi": 1.46, "Po": 1.53, "At": 1.47, "Ce": 1.65, "Pr": 1.65, "Nd": 1.64, "Pm": 1.63, "Sm": 1.62, "Eu": 1.85, "Gd": 1.61, "Tb": 1.59, "Dy": 1.59, "Ho": 1.58, "Er": 1.57, "Tm": 1.56, "Yb": 1.7, "Lu": 1.56, "Th": 1.65, "U": 1.42, "Gh": 1}
		self.atomic_mass = {"Ru": 102.91, "Pd": 106.4, "Pt": 195.09, "Ni": 58.71, "Mg": 24.305, "Na": 22.99, "Nb": 92.906, "Db": 268.0, "Ne": 20.179, "Li": 6.941, "Pb": 207.2, "Re": 128.207, "Tl": 204.37, "B": 10.81, "Ra": 226.03, "Rb": 85.468, "Ti": 47.9, "Rn": 222.0, "Cd": 112.41, "Po": 209.0, "Ta": 180.95, "Be": 9.0122, "Fr": 223.0, "Te": 127.6, "Ba": 137.33, "Os": 190.2, "La": 138.9, "Bh": 272.0, "Ge": 72.59, "Zr": 91.224, "Tc": 97.0, "Fe": 55.847, "Br": 79.904, "Sr": 87.62, "Hf": 178.49, "Hg": 200.59, "He": 4.0026, "C": 12.011, "Cl": 35.453, "Rf": 265.0, "P": 30.974, "F": 18.998, "I": 126.9, "H": 1.0079, "Mo": 95.94, "v": 50.941, "Ac": 227.0, "O": 15.999, "N": 14.007, "Kr": 83.8, "Si": 28.086, "Sn": 118.69, "W": 183.84, "Y": 88.906, "Sb": 121.75, "Bi": 206.98, "Al": 26.982, "Sg": 271.0, "Se": 78.96, "Sc": 44.955912, "Zn": 65.38, "Co": 58.933, "Ag": 107.87, "Mt": 276.0, "k": 39.096, "Ir": 192.22, "S": 32.06, "Xe": 131.3, "Mn": 54.938, "As": 74.922, "Ar": 39.948, "Au": 196.97, "At": 210.0, "Ga": 69.72, "Hs": 227.0, "Cs": 132.91, "Cr": 51.996, "Ca": 40.08, "Cu": 63.546, "In": 114.82}
		self.coolprop_names = {"He": "Helium", "Ne": "Neon", "Ar": "Argon", "Kr": "Krypton", "Xe": "Xenon", "CH4": "Methane", "CO2": "CO2", "N2": "Nitrogen", "H2": "Hydrogen", "H2O": "Water"}
		self.cell_a = 0
		self.cell_b = 0
		self.cell_c = 0
		self.cell_alpha = 0
		self.cell_beta = 0
		self.cell_gamma = 0
		self.cell_vec_a = []
		self.cell_vec_b = []
		self.cell_vec_c = []
		self.framework_atoms = []
		self.min_mol_num = 200
		self.bond_angle_data = []
		self.rcut = 12.5
		self.ini_var_adsorptive = 8
		self.forcefield = "MS_Dreiding"
		self.pmrotate = 0
		self.pmtracm = 0
		self.pmtraat = 0
		self.pm1boxcbswap = 0
		self.pm2boxcbswap = 0
		self.pmvol = 0
		self.cell_length = 0
		self.rcutin = 0
		self.rmin = 0
		self.ltailc = "T"
		self.lshift = "F"
		self.ff_filename = "/path/MS_Dreiding"
		self.volmaxdispfreq = 1000
		self.trmaxdispfreq = 10
		self.pressurefreq = 10
		self.pdb_output_freq = 0
		self.backupfreq = 0
		self.moviefreq = 0
		self.blocksize = 1000
		self.printfreq = 10000
		self.nstep = 3000000
		self.pressure = 70
		self.temperature = 273.15
		self.adsorptive = "Ar"
	
	#Koordinaten des Adsorbens aus Textdatei einlesen, ausgleichen von Ladungen
	def read_framework(self, filename):
		filestream = open(filename, "r")
		check_cell = 0
		check_data = 0
		for line in filestream:
			if "</cell>" in line:
				check_cell = 0
			if "</atom_x_y_z_charge>" in line:
				check_data = 0
			if check_cell==1:
				if line.split(" ")[0]=="a":
					self.cell_a = float(line.split(" ")[1])
				if line.split(" ")[0]=="b":
					self.cell_b = float(line.split(" ")[1])
				if line.split(" ")[0]=="c":
					self.cell_c = float(line.split(" ")[1])
				if line.split(" ")[0]=="alpha":
					self.cell_alpha = float(line.split(" ")[1])
				if line.split(" ")[0]=="beta":
					self.cell_beta = float(line.split(" ")[1])
				if line.split(" ")[0]=="gamma":
					self.cell_gamma = float(line.split(" ")[1])
			if check_data==1:
				self.framework_atoms.append([line.split(" ")[0], "fftype", float(line.split(" ")[1]), float(line.split(" ")[2]), float(line.split(" ")[3]), float(line.split(" ")[4])]) #Atom fftype x y z charge
			if "<cell>" in line:
				check_cell = 1
			if "<atom_x_y_z_charge>" in line:
				check_data = 1
		filestream.close()
		charge_test = 0
		for framework_atom in self.framework_atoms:
			charge_test += framework_atom[5]
		if charge_test!=0:
			print "Framework is charged! Distributing remaining charge of "+str(charge_test)+" e equally over all framework atoms.\n"
			for i in range(0,len(self.framework_atoms)):
				self.framework_atoms[i][5] -= charge_test/len(self.framework_atoms)
	
	#Simulationszelle des Adsorptivs skalieren bis Zieldichte erreicht
	def density_to_cubic_cell_mol_num(self,target_density,mol_mass):
		mass_in_g = mol_mass/self.avogadro
		cell_length = 0.001
		density = (self.min_mol_num*mass_in_g)/((cell_length**3)*10**-24)
		while density>target_density:
			V_in_ml = (cell_length**3)*10**-24
			density = (self.min_mol_num*mass_in_g)/V_in_ml
			cell_length += 0.1
		while density<target_density:
			V_in_ml = (cell_length**3)*10**-24
			density = (self.min_mol_num*mass_in_g)/V_in_ml
			cell_length -= 0.1			
		return int(self.min_mol_num), cell_length, (density-target_density)/target_density
	
	#Referenzdichte fuer Adsorptiv aus CoolProp-Datenbank
	def coolprop_density(self,pressure,temp,mol_coolprop_name):
		return CoolProp.CoolProp.Props("D","T",temp,"P",pressure,mol_coolprop_name)*10**-3 #Density converted from kg/L to g/mL	

	#Berechnen der Zellvektoren aus Gitterkonstanten	
	def unit_cell_vecs(self):
		cell_alpha = (self.cell_alpha/180)*numpy.pi
		cell_beta = (self.cell_beta/180)*numpy.pi
		cell_gamma = (self.cell_gamma/180)*numpy.pi
		x = 1
		y = 0
		z = 0
		X=self.cell_a*x+(self.cell_b*numpy.cos(cell_gamma))*y+(self.cell_c*numpy.cos(cell_beta))*z
		Y=(self.cell_b*numpy.sin(cell_gamma))*y+(-self.cell_c*numpy.sin(cell_beta)*(numpy.cos(cell_beta)*numpy.cos(cell_gamma)-numpy.cos(cell_alpha))/(numpy.sin(cell_beta)*numpy.sin(cell_gamma)))*z
		Z=(self.cell_c*numpy.sin(cell_beta)*numpy.sqrt(1-(numpy.cos(cell_beta)*numpy.cos(cell_gamma)-numpy.cos(cell_alpha))/(numpy.sin(cell_beta)*numpy.sin(cell_gamma))**2))*z
		self.cell_vec_a = numpy.array([round(X,5),round(Y,5),round(Z,5)])
		x = 0
		y = 1
		z = 0
		X=self.cell_a*x+(self.cell_b*numpy.cos(cell_gamma))*y+(self.cell_c*numpy.cos(cell_beta))*z
		Y=(self.cell_b*numpy.sin(cell_gamma))*y+(-self.cell_c*numpy.sin(cell_beta)*(numpy.cos(cell_beta)*numpy.cos(cell_gamma)-numpy.cos(cell_alpha))/(numpy.sin(cell_beta)*numpy.sin(cell_gamma)))*z
		Z=(self.cell_c*numpy.sin(cell_beta)*numpy.sqrt(1-(numpy.cos(cell_beta)*numpy.cos(cell_gamma)-numpy.cos(cell_alpha))/(numpy.sin(cell_beta)*numpy.sin(cell_gamma))**2))*z
		self.cell_vec_b = numpy.array([round(X,5),round(Y,5),round(Z,5)])
		x = 0
		y = 0
		z = 1
		X=self.cell_a*x+(self.cell_b*numpy.cos(cell_gamma))*y+(self.cell_c*numpy.cos(cell_beta))*z
		Y=(self.cell_b*numpy.sin(cell_gamma))*y+(-self.cell_c*numpy.sin(cell_beta)*(numpy.cos(cell_beta)*numpy.cos(cell_gamma)-numpy.cos(cell_alpha))/(numpy.sin(cell_beta)*numpy.sin(cell_gamma)))*z
		Z=(self.cell_c*numpy.sin(cell_beta)*numpy.sqrt(1-(numpy.cos(cell_beta)*numpy.cos(cell_gamma)-numpy.cos(cell_alpha))/(numpy.sin(cell_beta)*numpy.sin(cell_gamma))**2))*z
		self.cell_vec_c = numpy.array([round(X,5),round(Y,5),round(Z,5)])

	#Abstand zwischen zwei Koordinaten (xyz1, xyz2) 
	def calc_dist_xyz(self, xyz1, xyz2):
		delta_x = xyz1[0]-xyz2[0]
		delta_y = xyz1[1]-xyz2[1]
		delta_z = xyz1[2]-xyz2[2]
		delta_x = self.make_periodic(delta_x, self.cell_a)
		delta_y = self.make_periodic(delta_y, self.cell_b)
		delta_z = self.make_periodic(delta_z, self.cell_c)
		return numpy.sqrt((delta_x**2)+(delta_y**2)+(delta_z**2))

	#Anwenden von PBC
	def make_periodic(self, coord, cell_param):
		while (coord < -0.5*cell_param):
			coord = coord + cell_param
		while (coord > 0.5*cell_param):
			coord = coord - cell_param
		return coord
		
	#MCCCS erlaubt keine Bindungen, die kuerzer als 1 A sind: Skalieren von kuerzeren Bindungen auf 1.001 A	
	def correct_min_dist(self):
		for i in range(0,len(self.framework_atoms)):
			for j in range(0,len(self.framework_atoms)):
				if i!=j and (self.calc_dist_xyz(numpy.array(self.framework_atoms[i][2:5]), numpy.array(self.framework_atoms[j][2:5]))<1):
					print "Distance between atom "+str(i)+" and "+str(j)+" smaller than 1 A! Scaling to 1.001 A ..."
					if self.framework_atoms[i][0]=="H":
						#print self.framework_atoms[i][0]+" before "+str(self.framework_atoms[i][2:5])
						length_vec = numpy.array(self.framework_atoms[i][2:5])-numpy.array(self.framework_atoms[j][2:5])
						factor_length = 1.001/numpy.linalg.norm(length_vec)
						length_vec *= factor_length
						self.framework_atoms[i][2:5] = numpy.array(self.framework_atoms[j][2:5])+length_vec
						#print self.framework_atoms[i][0]+" after "+str(self.framework_atoms[i][2:5])
					else:
						if self.framework_atoms[j][0]=="H":
							#print self.framework_atoms[j][0]+" before "+str(self.framework_atoms[j][2:5])
							length_vec = numpy.array(self.framework_atoms[j][2:5])-numpy.array(self.framework_atoms[i][2:5])
							factor_length = 1.001/numpy.linalg.norm(length_vec)
							length_vec *= factor_length
							self.framework_atoms[j][2:5] = numpy.array(self.framework_atoms[i][2:5])+length_vec
							#print self.framework_atoms[j][0]+" after "+str(self.framework_atoms[j][2:5])
						#else:
						#	self.print_error("Distance between atom "+str(i)+" and "+str(j)+" smaller than 1 A! Scaling not possible!")
		
	#Ausgeben von Fehlern	
	def print_error(self, message):
		print "\nError Message from pyTowhee: "+str(message)
		print "\nScript stopped.\n"
		exit()
	
	#Zuweisen von Atomtypen des Adsorbens aus Datenbank 	
	def assign_framework_ff_types(self, framework_elements, ff_gui):
		ff_types = []
		conn = sqlite3.connect(self.pytowhee_root+"/force_field_100514.db")
		if "Dreiding" in ff_gui:
			for framework_element in framework_elements:
				type_cnt = 0
				cursor = conn.execute("SELECT DISTINCT Atom_Names from lj_parameters WHERE Element = '"+str(framework_element)+"' AND Force_Field_Name = 'DREIDING'")
				for row in cursor:
					type_cnt += 1
					ff_types.append([row[0], "DREIDING"])
					break
				if type_cnt<1:
					cursor = conn.execute("SELECT DISTINCT Atom_Names from lj_parameters WHERE Element = '"+str(framework_element)+"' AND Force_Field_Name = 'UFF'")
					for row in cursor:
						ff_types.append([row[0], "UFF"])
						break
		else:
			for framework_element in framework_elements:
				cursor = conn.execute("SELECT DISTINCT Atom_Names from lj_parameters WHERE Element = '"+str(framework_element)+"' AND Force_Field_Name = 'UFF'")
				for row in cursor:
					ff_types.append([row[0], "UFF"])
					break
		conn.close()
		return ff_types
	
	#Kraftfeldparameter aus Datenbank auslesen und Kraftfelddatei erzeugen
	def create_ff_file(self, ff_name, filename, framework_types, adsorptive, adsorptive_ff):
		epsilon_factor_framework = 1.0
		epsilon_factor_adsorptive = 1.0
		sigma_factor_framework = 1.0
		sigma_factor_adsorptive = 1.0
		conn = sqlite3.connect(self.pytowhee_root+"/force_field_100514.db")
		lj_atom_types = []
		bond_angle_data = []
		for framework_type in framework_types:
			cursor = conn.execute("SELECT DISTINCT Nonbond_Coefficients, Mass, Element, Bond_Pattern, Base_Charge, Polarizability, Force_Field_Name, Atom_Names, Description from lj_parameters WHERE Atom_Names = '"+str(framework_type[0])+"' AND Force_Field_Name = '"+str(framework_type[1])+"'")
			for row in cursor:
				Nonbond_Coefficients_list = row[0].split(";")
				lj_atom_types.append([float(Nonbond_Coefficients_list[0])*sigma_factor_framework, float(Nonbond_Coefficients_list[1])*epsilon_factor_framework, row[1], row[2], row[3], row[4], row[5], row[6], row[7]])
				for i in range(0,len(self.framework_atoms)):
					if self.framework_atoms[i][0]==row[2]:
						self.framework_atoms[i][1] = framework_type[0]
		cursor = conn.execute("SELECT DISTINCT Atom_Names1, Atom_Names2, Atom_Names3, Charge1, Charge2, Charge3, Bond_Length, Angle, Angle_Tolerance FROM three_parameters WHERE Adsorptive = '"+adsorptive+"' AND Force_Field_Name = '"+adsorptive_ff+"'")
		if len(cursor.fetchall())>0:
			cursor = conn.execute("SELECT Nonbond_Coefficients, Mass, Element, Bond_Pattern, Base_Charge, Polarizability, Force_Field_Name, Atom_Names, Description from lj_parameters WHERE Force_Field_Name = '"+str(adsorptive_ff)+"'")
			for row in cursor:
				Nonbond_Coefficients_list = row[0].split(";")
				lj_atom_types.append([float(Nonbond_Coefficients_list[0])*sigma_factor_adsorptive, float(Nonbond_Coefficients_list[1])*epsilon_factor_adsorptive, row[1], row[2], row[3], row[4], row[5], row[6], row[7]])
			cursor = conn.execute("SELECT DISTINCT Atom_Names1, Atom_Names2, Atom_Names3, Charge1, Charge2, Charge3, Bond_Length, Angle, Angle_Tolerance FROM three_parameters WHERE Adsorptive = '"+adsorptive+"' AND Force_Field_Name = '"+adsorptive_ff+"'")
			for row in cursor:
				self.bond_angle_data = [row[0], row[1], row[2], float(row[3]), float(row[4]), float(row[5]), float(row[6]), float(row[7]), float(row[8])]
		else:
			cursor = conn.execute("SELECT DISTINCT Nonbond_Coefficients, Mass, Element, Bond_Pattern, Base_Charge, Polarizability, Force_Field_Name, Atom_Names, Description from lj_parameters WHERE Atom_Names = '"+str(adsorptive)+"' AND Force_Field_Name = '"+str(adsorptive_ff)+"'")
			for row in cursor:
				Nonbond_Coefficients_list = row[0].split(";")
				lj_atom_types.append([float(Nonbond_Coefficients_list[0])*sigma_factor_adsorptive, float(Nonbond_Coefficients_list[1])*epsilon_factor_adsorptive, row[1], row[2], row[3], row[4], row[5], row[6], row[7]])
		conn.close()
		#print lj_atom_types
		#print bond_angle_data
		fo = open(filename, "w")
		fo.write("towhee_ff Version\n")
		fo.write("14\n")
		fo.write("Number of Nonbonded Types\n")
		fo.write(str(len(lj_atom_types))+"\n")
		fo.write("Potential Type\n")
		fo.write("Lennard-Jones\n")
		fo.write("Classical Mixrule\n")
		fo.write("Lorentz-Berthelot\n")
		type_nr = 1
		for lj_atom_type in lj_atom_types:
			fo.write("Atom Type Number\n")
			fo.write(str(type_nr)+"\n")
			fo.write("Nonbond Coefficients\n")
			fo.write(str(lj_atom_type[0])+"\n")
			fo.write(str(lj_atom_type[1])+"\n")
			fo.write("0.0000000000E+00\n")
			fo.write("0.0000000000E+00\n")
			fo.write("Mass\n")
			fo.write(str(lj_atom_type[2])+"\n")
			fo.write("Element\n")
			fo.write(str(lj_atom_type[3])+"\n")
			fo.write("Bond Pattern\n")
			fo.write(str(lj_atom_type[4])+"\n")
			fo.write("Base Charge\n")
			fo.write(str(lj_atom_type[5])+"\n")
			fo.write("Polarizability\n")
			fo.write(str(lj_atom_type[6])+"\n")
			fo.write("Force Field Name\n")
			fo.write(ff_name+"\n")
			fo.write("Atom Names\n")
			fo.write(str(lj_atom_type[8])+(10-len(lj_atom_type[8]))*" "+"\n")
			fo.write(str(lj_atom_type[8])+(10-len(lj_atom_type[8]))*" "+"\n")
			fo.write(str(lj_atom_type[8])+(10-len(lj_atom_type[8]))*" "+"\n")
			fo.write(str(lj_atom_type[8])+(10-len(lj_atom_type[8]))*" "+"\n")
			type_nr += 1
		if len(self.bond_angle_data)>0:
			bond_string = self.bond_angle_data[0]+(11-len(self.bond_angle_data[0]))*" "+self.bond_angle_data[1]+(10-len(self.bond_angle_data[1]))*" "
			angle_string = self.bond_angle_data[0]+(11-len(self.bond_angle_data[0]))*" "+self.bond_angle_data[1]+(11-len(self.bond_angle_data[1]))*" "+self.bond_angle_data[2]+(10-len(self.bond_angle_data[2]))*" "
			fo.write("Number of Bonded Terms\n")
			fo.write("1\n")
			fo.write("Bond Type Number\n")
			fo.write("1\n")
			fo.write("Bond Style\n")
			fo.write("1\n")
			fo.write("Bond Coefficients\n")
			fo.write(str(self.bond_angle_data[6])+"\n")
			fo.write("Vibration Order\n")
			fo.write("wild\n")
			fo.write("Force Field Name\n")
			fo.write(ff_name+"\n")
			fo.write("Number of Atoms with Same Parameters\n")  
			fo.write("1\n")
			fo.write("Atom Names\n")
			fo.write(bond_string+"\n")
			fo.write("Number of Angle Terms\n")
			fo.write("1\n")
			fo.write("Angle Type Number\n")
			fo.write("1\n")
			fo.write("Angle Style\n")
			fo.write("0\n")
			fo.write("Angle Coefficients\n")
			fo.write(str(self.bond_angle_data[7])+"\n")
			fo.write(str(self.bond_angle_data[8])+"\n")
			fo.write("Angle Order\n")
			fo.write("wild\n")    
			fo.write("Force Field Name\n")
			fo.write(ff_name+"\n")
			fo.write("Number of Atoms with Same Parameters\n")  
			fo.write("1\n")
			fo.write("Atom Names\n")
			fo.write(angle_string+"\n")
		else:
			fo.write("Number of Bonded Terms\n")
			fo.write("0\n")
			fo.write("Number of Angle Terms\n")
			fo.write("0\n")
		fo.write("Number of Torsion Terms\n")
		fo.write("0\n")
		fo.write("Number of Improper Terms\n")
		fo.write("0\n")
		fo.write("Number of Angle-Angle Terms\n")
		fo.write("0\n")
		fo.write("Number of One-Five Types\n")
		fo.write("0\n")
		fo.write("Number of Bond Increments\n")
		fo.write("0\n")
		fo.close()
		print "Force field file \""+filename+"\" with "+str(len(lj_atom_types))+" LJ types created."
	
	#Inputdatei erzeugen
	def create_input_files(self, input_filename, coords_filename):
		fo = open(coords_filename, "w")
		for framework_atom in self.framework_atoms:
			fo.write(str(framework_atom[2])+" "+str(framework_atom[3])+" "+str(framework_atom[4])+" 0     # "+framework_atom[1]+" - "+framework_atom[0]+"\n")
		fo.close()
		lengths_list = [numpy.linalg.norm(self.cell_vec_a)]
		lengths_list.append(numpy.linalg.norm(self.cell_vec_b))
		lengths_list.append(numpy.linalg.norm(self.cell_vec_c))
		lengths_list.sort()
		if 2*self.rcut>lengths_list[0]:
			self.rcut = lengths_list[0]/2
			print "Unit cell too small for given cut off. Reduced cut off to "+str(self.rcut)+" A."		
		self.ini_var_adsorptive = int(math.ceil(self.min_mol_num**(1./3))) #Ensure that inix, iniy, iniz are big enough, but not too big
		fo = open(input_filename, "w")
		fo.write("inputformat\n")
		fo.write("'Towhee'\n")
		fo.write("ensemble\n")
		fo.write("'npt'\n")
		fo.write("temperature\n")
		fo.write(str(self.temperature)+"\n")
		fo.write("pressure\n")
		fo.write(str(self.pressure)+"\n")
		fo.write("nmolty\n")
		fo.write("2\n")
		fo.write("nmolectyp\n")
		fo.write("1 "+str(self.min_mol_num)+" \n")
		fo.write("numboxes\n")
		fo.write("2\n")
		fo.write("stepstyle\n")
		fo.write("'moves'\n")
		fo.write("nstep\n")
		fo.write(str(self.nstep)+"\n")
		fo.write("printfreq\n")
		fo.write(str(self.printfreq)+"\n")
		fo.write("blocksize\n")
		fo.write(str(self.blocksize)+"\n")
		fo.write("moviefreq\n")
		fo.write(str(self.moviefreq)+"\n")
		fo.write("backupfreq\n")
		fo.write(str(self.backupfreq)+"\n")
		fo.write("runoutput\n")
		fo.write("'none'\n")
		fo.write("pdb_output_freq\n")
		fo.write(str(self.pdb_output_freq)+"\n")
		fo.write("pressurefreq\n")
		fo.write(str(self.pressurefreq)+"\n")
		fo.write("trmaxdispfreq\n")
		fo.write(str(self.trmaxdispfreq)+"\n")
		fo.write("volmaxdispfreq\n")
		fo.write(str(self.volmaxdispfreq)+"\n")
		fo.write("potentialstyle\n")
		fo.write("'internal'\n")
		fo.write("ffnumber\n")
		fo.write("1\n")
		fo.write("ff_filename\n")
		fo.write(str(self.ff_filename)+"\n")
		fo.write("classical_potential\n")
		fo.write("'Lennard-Jones'\n")
		fo.write("classical_mixrule\n")
		fo.write("'Lorentz-Berthelot'\n")
		fo.write("lshift\n")
		fo.write(str(self.lshift)+"\n")
		fo.write("ltailc\n")
		fo.write(str(self.ltailc)+"\n")
		fo.write("rmin\n")
		fo.write(str(self.rmin)+"\n")
		fo.write("rcut\n")
		fo.write(str(self.rcut)+"\n")
		fo.write("rcutin\n")
		fo.write(str(self.rcutin)+"\n")
		if len(self.bond_angle_data)>0:
			fo.write("electrostatic_form\n")
			fo.write("'coulomb'\n")
			fo.write("coulombstyle\n")
			fo.write("'ewald_fixed_kmax'\n")
			fo.write("kalp \n")
			fo.write("5.6d0\n")
			fo.write("kmax\n")
			fo.write("5\n")
			fo.write("dielect\n")
			fo.write("1.0d0\n")
		else:
			fo.write("electrostatic_form\n")
			fo.write("'none'\n")
		fo.write("nfield\n")
		fo.write("0\n")
		fo.write("solvation_style\n")
		fo.write("'none'\n")
		fo.write("linit\n")
		fo.write("T\n")
		fo.write("initboxtype\n")
		fo.write("'dimensions'\n")
		fo.write("initstyle\n")
		fo.write("'coords' 'none'\n")
		fo.write("'none' 'full cbmc'\n")
		fo.write("initlattice\n")
		fo.write("'none' 'none'\n")
		fo.write("'none' 'simple cubic'\n")
		fo.write("initmol\n")
		fo.write("1 0\n")
		fo.write("0 "+str(self.min_mol_num)+"\n")
		fo.write("inix iniy iniz\n")
		fo.write("1   1   1\n")
		fo.write(str(self.ini_var_adsorptive)+"   "+str(self.ini_var_adsorptive)+"   "+str(self.ini_var_adsorptive)+"\n")
		fo.write("hmatrix\n")
		fo.write(str(self.cell_vec_a[0])+" "+str(self.cell_vec_a[1])+" "+str(self.cell_vec_a[2])+"\n")
		fo.write(str(self.cell_vec_b[0])+" "+str(self.cell_vec_b[1])+" "+str(self.cell_vec_b[2])+"\n")
		fo.write(str(self.cell_vec_c[0])+" "+str(self.cell_vec_c[1])+" "+str(self.cell_vec_c[2])+"\n")
		fo.write(str(self.cell_length)+" 0 0\n")
		fo.write("0 "+str(self.cell_length)+" 0\n")
		fo.write("0 0 "+str(self.cell_length)+"\n")
		fo.write("pmvol\n")     
		fo.write(str(self.pmvol)+"\n")   
		fo.write("  pmvlpr\n")
		fo.write("  0.0d0 1.0d0\n")
		fo.write("  rmvol\n")
		fo.write("  0.1d0\n")
		fo.write("  tavol\n")
		fo.write("  0.5d0\n")
		fo.write("pm2boxcbswap\n")
		fo.write(str(self.pm2boxcbswap)+"\n")
		fo.write("  pm2cbswmt\n")
		fo.write("  0.0d0 1.0d0\n")
		fo.write("  pm2cbswpr\n")
		fo.write("  1.0d0\n")
		fo.write("pm1boxcbswap\n")
		fo.write(str(self.pm1boxcbswap)+"\n")
		fo.write("  pm1cbswmt\n")
		fo.write("  0.0d0 1.0d0\n")
		fo.write("pmtraat\n")
		fo.write(str(self.pmtraat)+"\n")
		fo.write("  pmtamt\n")
		fo.write("  0.0d0 1.0d0\n")
		fo.write("  rmtraa\n")
		fo.write("  0.5d0\n")
		fo.write("  tatraa\n")
		fo.write("  0.5d0\n")
		fo.write("pmtracm\n")
		fo.write(str(self.pmtracm)+"\n")
		fo.write("  pmtcmt\n")
		fo.write("  0.0d0 1.0d0\n")      	
		fo.write("  rmtrac\n")
		fo.write("  0.5d0\n")
		fo.write("  tatrac\n")
		fo.write("  0.5d0\n")
		fo.write("pmrotate\n")
		fo.write(str(self.pmrotate)+"\n")
		fo.write("  pmromt\n")
		fo.write("  0.0d0 1.0d0\n")
		fo.write("  rmrot\n")
		fo.write("  0.05d0\n")
		fo.write("  tarot\n")
		fo.write("  0.5d0\n")
		fo.write("cbmc_formulation\n")
		fo.write("'Martin and Frischknecht 2006'\n")
		fo.write("cbmc_setting_style\n")
		fo.write("'Martin and Frischknecht'\n")
		fo.write("input_style\n")
		fo.write("'basic connectivity map'\n")
		fo.write("nunit\n")
		fo.write(str(len(self.framework_atoms))+"\n")
		fo.write("nmaxcbmc\n")
		fo.write(str(len(self.framework_atoms))+"\n")
		fo.write("lpdbnames\n")
		fo.write("F\n")
		fo.write("forcefield\n")
		fo.write("'"+str(self.forcefield)+"'\n")
		fo.write("charge_assignment\n")
		fo.write("'manual'\n")
		framework_atom_cnt = 1
		for framework_atom in self.framework_atoms:
			fo.write("unit ntype qqatom\n")
			fo.write(str(framework_atom_cnt)+" '"+str(framework_atom[1])+"' "+str(framework_atom[5])+"\n")
			fo.write("vibration\n")
			fo.write("0\n")
			fo.write("improper torsion\n")
			fo.write("0\n")
			framework_atom_cnt += 1
		fo.write("input_style\n")
		fo.write("'basic connectivity map'\n")
		if len(self.bond_angle_data)>0:
			fo.write("nunit\n")
			fo.write("3\n")
			fo.write("nmaxcbmc\n")
			fo.write("3\n")
			fo.write("lpdbnames\n")
			fo.write("F\n")
			fo.write("forcefield\n")
			fo.write("'"+str(self.forcefield)+"'\n")
			fo.write("charge_assignment\n")
			fo.write("'manual'\n")
			fo.write("unit ntype qqatom \n")
			fo.write("1 '"+str(self.bond_angle_data[0])+"' "+str(self.bond_angle_data[3])+"\n")
			fo.write("vibration\n")
			fo.write("1\n")
			fo.write("2\n")
			fo.write("improper torsion\n")
			fo.write("0\n")
			fo.write("unit ntype qqatom \n")
			fo.write("2 '"+str(self.bond_angle_data[1])+"' "+str(self.bond_angle_data[4])+"\n")
			fo.write("vibration\n")
			fo.write("2\n")
			fo.write("1 3\n")
			fo.write("improper torsion\n")
			fo.write("0\n")
			fo.write("unit ntype qqatom\n") 
			fo.write("3 '"+str(self.bond_angle_data[2])+"' "+str(self.bond_angle_data[5])+"\n")
			fo.write("vibration\n")
			fo.write("1\n")
			fo.write("2\n")
			fo.write("improper torsion\n")
			fo.write("0\n")
		else:
			fo.write("nunit\n")
			fo.write("1\n")
			fo.write("nmaxcbmc\n")
			fo.write("1\n")
			fo.write("lpdbnames\n")
			fo.write("F\n")
			fo.write("forcefield\n")
			fo.write("'"+str(self.forcefield)+"'\n")
			fo.write("charge_assignment\n")
			fo.write("'manual'\n")
			fo.write("unit ntype qqatom\n")
			fo.write("1 '"+self.adsorptive+"' 0\n")
			fo.write("vibration\n")
			fo.write("0\n")
			fo.write("improper torsion\n")
			fo.write("0\n")
		fo.close()

#Erstellen von Hauptverzeichnis fuer Projekt		
def create_towhee_project(dirname):
	#if "/" not in dirname:
	#	dirname = "./"+dirname
	try:
		os.stat(dirname)
	except:
		os.mkdir(dirname)
	os.chdir(str(dirname))
	return dirname

#Erzeugt py-Dateien zum lokalen Starten von Rechnungen (nicht fuer RRZN)	
def create_py_script_isotherms(start_paths):
	if len(start_paths)>20:
		lenRegular = len(start_paths)
		lenReduced = len(start_paths)-(len(start_paths)%20)
		lenRemaining = len(start_paths)%20
		for i in range((lenReduced)/20):
			pyFilename = "start"+str(i+1)+".py"
			fo = open(pyFilename, "w")
			fo.write("import os\n\n")
			for j in range(i*20, i*20+20):
				fo.write("start_path = \""+str(start_paths[j])+"\"\n")
				fo.write("os.chdir(start_path)\n")
				fo.write("cmd = \"towhee towhee_input > out&\"\n")
				fo.write("os.system(cmd)\n\n")
			fo.close()
		if lenRemaining>0:
			pyFilename = "start"+str(i+2)+".py"
			fo = open(pyFilename, "w")
			fo.write("import os\n\n")
			for i in range((i+1)*20, len(start_paths)):
				fo.write("start_path = \""+str(start_paths[i])+"\"\n")
				fo.write("os.chdir(start_path)\n")
				fo.write("cmd = \"towhee towhee_input > out&\"\n")
				fo.write("os.system(cmd)\n\n")
			fo.close()
	else:	
		fo = open("start.py", "w")
		fo.write("import os\n\n")
		for start_path in start_paths:
			fo.write("start_path = \""+str(start_path)+"\"\n")
			fo.write("os.chdir(start_path)\n")
			fo.write("cmd = \"towhee towhee_input > out&\"\n")
			fo.write("os.system(cmd)\n\n")
		fo.close()

#Erzeugt Dateien zum Starten vo Rechnungen bei RRZN (hier Pfad fuer Verzeichnis anpassen)
def rrzn_py_scripts(start_paths, start_names, ff_file, rrzn_ram, rrzn_walltime):
	fo = open("dos2unix.py", "w")
	fo.write("import os\n\n")
	for start_path in start_paths:
		fo.write("start_path = \""+str(start_path)+"\"\n")
		fo.write("os.chdir(start_path)\n")
		fo.write("cmd = \"dos2unix towhee_input\"\n")
		fo.write("os.system(cmd)\n")
		fo.write("cmd = \"dos2unix towhee_coords\"\n")
		fo.write("os.system(cmd)\n")
		fo.write("cmd = \"dos2unix "+str(ff_file)+"\"\n") #Has to be adapted
		fo.write("os.system(cmd)\n\n")
	fo.close()
	
	for i in range(0,len(start_names)):
		job_filename = str(start_names[i])+".job"
		fo = open(job_filename, "w")
		fo.write("#!/bin/bash -login\n")
		fo.write("#PBS -N "+str(start_names[i])+"\n") #Name in the queue
		fo.write("#PBS -l nodes=1:ppn=1\n") #1 Node, 1 core
		fo.write("#PBS -l walltime="+str(rrzn_walltime)+":00:00\n") #Walltime
		fo.write("#PBS -l mem="+str(rrzn_ram)+"gb\n") #RAM
		fo.write("#PBS -o "+str(start_names[i])+".log\n") #Logile
		fo.write("#PBS -j eo\n")
		fo.write("#PBS -m e\n")
		fo.write("#PBS -M xxx@xxx.de\n")
		fo.write("#  Wechsel in das Working Directory\n")
		fo.write("cd "+str(start_paths[i])+"\n") #Dir of the towhee_input file
		fo.write("# Job starten\n")
		fo.write("/home/xxx/towhee towhee_input > out\n") #Path of the towhee executable
		#fo.write("/home/xxx/towhee towhee_input > out\n") #Path of the towhee executable
		fo.close()
	
	fo = open("qsub_jobs.sh", "w")
	for i in range(0,len(start_names)):
		fo.write("qsub "+str(start_names[i])+".job\n")
	fo.close()

#Erzeugt lineares Druckintervall	
def gen_pressure_load_range(range_list):
	interv_list = []
	for range_entry in range_list:
		range_entry[2] -= 1
		for i in range(0,range_entry[2]):
			interv_list.append([round((range_entry[0]+i*((range_entry[1]-range_entry[0])/range_entry[2])),7), range_entry[3]])
		interv_list.append([range_entry[1], range_entry[3]])
	return interv_list

#Erzeugt logarithmisches Druckintervall	
def gen_pressure_load_range_lg(range_list):
	interv_list = []
	for range_entry in range_list:
		range_entry[2] -= 1
		for i in range(0,range_entry[2]):
			start_log = numpy.log10(range_entry[0])
			end_log = numpy.log10(range_entry[1])
			#print start_log+i*((end_log-start_log)/range_entry[2])
			interv_list.append([round(10**(numpy.log10(range_entry[0])+i*((numpy.log10(range_entry[1])-numpy.log10(range_entry[0]))/range_entry[2])),7), range_entry[3]])
		#print end_log
		interv_list.append([round(range_entry[1],7), range_entry[3]])
	return interv_list

#Erzeugen der Fensterinhalte fuer Tkinter	
mainframe = Tkinter.Frame(pyTowheeRoot)
mainframe.grid()
Tkinter.Label(mainframe, text="Project Name").grid(row=0, sticky="W")
project_name_entry = Tkinter.Entry(mainframe)
project_name_entry.grid(row=0, column=1, sticky="W")
Tkinter.Label(mainframe, text="Short Description").grid(row=1, sticky="W")
description_entry = Tkinter.Entry(mainframe)
description_entry.grid(row=1, column=1, sticky="W")
Tkinter.Label(mainframe, text="Local root directory").grid(row=2, sticky="W")
root_dir_entry = Tkinter.Entry(mainframe)
root_dir_entry.grid(row=2, column=1, sticky="W")
root_dir_button = Tkinter.Button(mainframe, text="Select Directory", command=select_dir)
root_dir_button.grid(row=2, column=2, sticky="W")
Tkinter.Label(mainframe, text="Remote root directory").grid(row=3, sticky="W")
remote_root_entry = Tkinter.Entry(mainframe)
remote_root_entry.grid(row=3, column=1, sticky="W")
remote_root_entry.insert(0, "/home/user/root_dir")
Tkinter.Label(mainframe, text="Force field file").grid(row=4, sticky="W")
ff_file_entry = Tkinter.Entry(mainframe)
ff_file_entry.grid(row=4, column=1, sticky="W")
ff_file_entry.insert(0, "MS_Dreiding")
Tkinter.Label(mainframe, text="Adsorbent file").grid(row=5, sticky="W")
adsorbent_option_choices = list_files("./structures/")
adsorbent_option_choices_start = Tkinter.StringVar(mainframe)
adsorbent_option_choices_start.set(adsorbent_option_choices[0])
adsorbent_option = Tkinter.OptionMenu(mainframe, adsorbent_option_choices_start, *adsorbent_option_choices)
adsorbent_option.grid(row=5, column=1, sticky="W")
Tkinter.Label(mainframe, text="Adsorbent force field").grid(row=6, sticky="W")
adsorbent_ff_option_choices = ["Dreiding (+UFF)", "UFF"]
adsorbent_ff_option_choices_start = Tkinter.StringVar(mainframe)
adsorbent_ff_option_choices_start.set(adsorbent_ff_option_choices[0])
adsorbent_ff_option = Tkinter.OptionMenu(mainframe, adsorbent_ff_option_choices_start, *adsorbent_ff_option_choices)
adsorbent_ff_option.grid(row=6, column=1, sticky="W")
Tkinter.Label(mainframe, text="Adsorptive").grid(row=7, sticky="W")
adsorptive_atom_name_list, adsorptive_ff_name_list, adsorptive_display_list = list_adsorptives()
adsorptive_option_choices = adsorptive_display_list
adsorptive_option_choices_start = Tkinter.StringVar(mainframe)
adsorptive_option_choices_start.set(adsorptive_option_choices[0])
adsorptive_option = Tkinter.OptionMenu(mainframe, adsorptive_option_choices_start, *adsorptive_option_choices)
adsorptive_option.grid(row=7, column=1, sticky="W")
Tkinter.Label(mainframe, text="Adsorptive molar mass / g/mol").grid(row=8, sticky="W")
adsorptive_M_entry = Tkinter.Entry(mainframe)
adsorptive_M_entry.grid(row=8, column=1, sticky="W")
adsorptive_M_entry.insert(0, "0.0")
Tkinter.Label(mainframe, text="Start pressure / kPa").grid(row=9, sticky="W")
start_p_entry = Tkinter.Entry(mainframe)
start_p_entry.grid(row=9, column=1, sticky="W")
start_p_entry.insert(0, "0.0")
Tkinter.Label(mainframe, text="End pressure / kPa").grid(row=10, sticky="W")
end_p_entry = Tkinter.Entry(mainframe)
end_p_entry.grid(row=10, column=1, sticky="W")
end_p_entry.insert(0, "0.0")
Tkinter.Label(mainframe, text="Number of state points").grid(row=11, sticky="W")
num_points_entry = Tkinter.Entry(mainframe)
num_points_entry.grid(row=11, column=1, sticky="W")
num_points_entry.insert(0, "20")
Tkinter.Label(mainframe, text="Pressure range").grid(row=12, sticky="W")
p_range_option_choices = ["Linear", "Logarithmic"]
p_range_option_choices_start = Tkinter.StringVar(mainframe)
p_range_option_choices_start.set(p_range_option_choices[1])
p_range_option = Tkinter.OptionMenu(mainframe, p_range_option_choices_start, *p_range_option_choices)
p_range_option.grid(row=12, column=1, sticky="W")
Tkinter.Label(mainframe, text="Expected loading >=0.1 kPa").grid(row=13, sticky="W")
min_load_entry = Tkinter.Entry(mainframe)
min_load_entry.grid(row=13, column=1, sticky="W")
min_load_entry.insert(0, "200")
Tkinter.Label(mainframe, text="Highest expected loading").grid(row=14, sticky="W")
max_load_entry = Tkinter.Entry(mainframe)
max_load_entry.grid(row=14, column=1, sticky="W")
max_load_entry.insert(0, "900")
Tkinter.Label(mainframe, text="Temperature / K").grid(row=15, sticky="W")
temperature_entry = Tkinter.Entry(mainframe)
temperature_entry.grid(row=15, column=1, sticky="W")
temperature_entry.insert(0, "87.45")
Tkinter.Label(mainframe, text="Cut off / A").grid(row=16, sticky="W")
rcut_entry = Tkinter.Entry(mainframe)
rcut_entry.grid(row=16, column=1, sticky="W")
rcut_entry.insert(0, "12.5")
Tkinter.Label(mainframe, text="Inner cut off / A").grid(row=17, sticky="W")
rcutin_entry = Tkinter.Entry(mainframe)
rcutin_entry.grid(row=17, column=1, sticky="W")
rcutin_entry.insert(0, "5.0")
Tkinter.Label(mainframe, text="Cut off correction").grid(row=18, sticky="W")
cut_corr_option_choices = ["Tail", "Shift"]
cut_corr_option_choices_start = Tkinter.StringVar(mainframe)
cut_corr_option_choices_start.set(cut_corr_option_choices[0])
cut_corr_option = Tkinter.OptionMenu(mainframe, cut_corr_option_choices_start, *cut_corr_option_choices)
cut_corr_option.grid(row=18, column=1, sticky="W")
Tkinter.Label(mainframe, text="Number of MC steps").grid(row=0, column=3, sticky="W")
nstep_entry = Tkinter.Entry(mainframe)
nstep_entry.grid(row=0, column=4, sticky="W")
nstep_entry.insert(0, "5000000")
Tkinter.Label(mainframe, text="Print frequency").grid(row=1, column=3, sticky="W")
printfreq_entry = Tkinter.Entry(mainframe)
printfreq_entry.grid(row=1, column=4, sticky="W")
printfreq_entry.insert(0, "1000")
Tkinter.Label(mainframe, text="Block size").grid(row=2, column=3, sticky="W")
blocksize_entry = Tkinter.Entry(mainframe)
blocksize_entry.grid(row=2, column=4, sticky="W")
blocksize_entry.insert(0, "100000")
Tkinter.Label(mainframe, text="Movie frequency").grid(row=3, column=3, sticky="W")
moviefreq_entry = Tkinter.Entry(mainframe)
moviefreq_entry.grid(row=3, column=4, sticky="W")
moviefreq_entry.insert(0, "0")
Tkinter.Label(mainframe, text="Backup frequency").grid(row=4, column=3, sticky="W")
backupfreq_entry = Tkinter.Entry(mainframe)
backupfreq_entry.grid(row=4, column=4, sticky="W")
backupfreq_entry.insert(0, "0")
Tkinter.Label(mainframe, text="trmaxdispfreq").grid(row=5, column=3, sticky="W")
trmaxdispfreq_entry = Tkinter.Entry(mainframe)
trmaxdispfreq_entry.grid(row=5, column=4, sticky="W")
trmaxdispfreq_entry.insert(0, "1")
Tkinter.Label(mainframe, text="volmaxdispfreq").grid(row=6, column=3, sticky="W")
volmaxdispfreq_entry = Tkinter.Entry(mainframe)
volmaxdispfreq_entry.grid(row=6, column=4, sticky="W")
volmaxdispfreq_entry.insert(0, "1000")
Tkinter.Label(mainframe, text="PDB output frequency").grid(row=7, column=3, sticky="W")
pdb_output_freq_entry = Tkinter.Entry(mainframe)
pdb_output_freq_entry.grid(row=7, column=4, sticky="W")
pdb_output_freq_entry.insert(0, "0")
Tkinter.Label(mainframe, text="Pressure frequency").grid(row=8, column=3, sticky="W")
pressurefreq_entry = Tkinter.Entry(mainframe)
pressurefreq_entry.grid(row=8, column=4, sticky="W")
pressurefreq_entry.insert(0, "10")
Tkinter.Label(mainframe, text="pmvol").grid(row=9, column=3, sticky="W")
pmvol_entry = Tkinter.Entry(mainframe)
pmvol_entry.grid(row=9, column=4, sticky="W")
pmvol_entry.insert(0, "0.01")
Tkinter.Label(mainframe, text="pm2boxcbswap").grid(row=10, column=3, sticky="W")
pm2boxcbswap_entry = Tkinter.Entry(mainframe)
pm2boxcbswap_entry.grid(row=10, column=4, sticky="W")
pm2boxcbswap_entry.insert(0, "0.2")
Tkinter.Label(mainframe, text="pm1boxcbswap").grid(row=11, column=3, sticky="W")
pm1boxcbswap_entry = Tkinter.Entry(mainframe)
pm1boxcbswap_entry.grid(row=11, column=4, sticky="W")
pm1boxcbswap_entry.insert(0, "0.1")
Tkinter.Label(mainframe, text="pmtraat").grid(row=12, column=3, sticky="W")
pmtraat_entry = Tkinter.Entry(mainframe)
pmtraat_entry.grid(row=12, column=4, sticky="W")
pmtraat_entry.insert(0, "0.0")
Tkinter.Label(mainframe, text="pmtracm").grid(row=13, column=3, sticky="W")
pmtracm_entry = Tkinter.Entry(mainframe)
pmtracm_entry.grid(row=13, column=4, sticky="W")
pmtracm_entry.insert(0, "1.0")
Tkinter.Label(mainframe, text="pmrotate").grid(row=14, column=3, sticky="W")
pmrotate_entry = Tkinter.Entry(mainframe)
pmrotate_entry.grid(row=14, column=4, sticky="W")
pmrotate_entry.insert(0, "0.0")
Tkinter.Label(mainframe, text="RRZN RAM / GB").grid(row=15, column=3, sticky="W")
rrzn_ram_entry = Tkinter.Entry(mainframe)
rrzn_ram_entry.grid(row=15, column=4, sticky="W")
rrzn_ram_entry.insert(0, "2")
Tkinter.Label(mainframe, text="RRZN Walltime / h").grid(row=16, column=3, sticky="W")
rrzn_walltime_entry = Tkinter.Entry(mainframe)
rrzn_walltime_entry.grid(row=16, column=4, sticky="W")
rrzn_walltime_entry.insert(0, "80")
submit_button = Tkinter.Button(mainframe, text="Generate input files!", command=submit_data)
submit_button.grid(row=19, column=4, sticky="W")

#Starten des Fensters
menu = Tkinter.Menu(pyTowheeRoot)
pyTowheeRoot.config(menu=menu)
filemenu = Tkinter.Menu(menu)
menu.add_cascade(label="File", menu=filemenu)
filemenu.add_command(label="Open", command=load_from_db)
filemenu.add_command(label="Save", command=save_to_db)
filemenu.add_separator()
filemenu.add_command(label="Exit", command=exit)

pyTowheeRoot.mainloop()